# Weekly VPNKit dev report for 2017-04-17 to 2017-04-23 (week 16)

This report covers weekly developments in the [moby/vpnkit], [mirage/ocaml-dns], [mirage/ocaml-hvsock], [djs55/ocaml-osx-dnssd] and [mirage/mirage-tcpip] repositories.

**TL;DR:** There were more DNS fixes around the handling of `localhost`, to address bugs
reported downstream by Docker for Mac users. This involved disabling the use of multicast DNS on macOS.

## PRs merged

- Do not attempt to look up `localhost.local` via mDNS ([moby/vpnkit#211]), and then entirely disable mDNS on macOS ([moby/vpnkit#213] [@djs55]).
- Rename the project from the `docker/` org to the `moby/` organisation ([moby/vpnkit#212] [@djs55]).

### PRs with activity

The [Lwt 3.0.0](https://github.com/ocsigen/lwt/releases/tag/3.0.0) release features several deprecated functions
and a rearrangement of the packages to be more consistent. Several of the VPNKit packages are being updated to
use the recommended interfaces and remain backwards compatible with older Lwt releases
([mirage/ocaml-dns#136] [mirage/mirage-tcpip#308] [@aantron] [@djs55] [@yomimono]).

The effort to add HTTP proxy support has stalled until upstream packages such as Cohttp integrated some
improvements ([moby/vpnkit#20] [@dave-tucker] [@avsm]).
Help welcome in this space; contact [@djs55] if interested!

Other reports in this series can be browsed directly in the repository at [moby/vpnkit:/reports](https://github.com/moby/vpnkit/tree/master/reports/).

[@aantron]: https://github.com/aantron
[@dave-tucker]: https://github.com/dave-tucker
[@djs55]: https://github.com/djs55
[@yomimono]: https://github.com/yomimono
[djs55/ocaml-osx-dnssd]: https://github.com/djs55/ocaml-osx-dnssd
[mirage/mirage-tcpip]: https://github.com/mirage/mirage-tcpip
[mirage/mirage-tcpip#308]: https://github.com/mirage/mirage-tcpip/pull/308
[mirage/ocaml-dns]: https://github.com/mirage/ocaml-dns
[mirage/ocaml-dns#136]: https://github.com/mirage/ocaml-dns/pull/136
[mirage/ocaml-hvsock]: https://github.com/mirage/ocaml-hvsock
[moby/vpnkit]: https://github.com/moby/vpnkit
[moby/vpnkit#20]: https://github.com/moby/vpnkit/issues/20
[moby/vpnkit#211]: https://github.com/moby/vpnkit/pull/211
[moby/vpnkit#212]: https://github.com/moby/vpnkit/pull/212
[moby/vpnkit#213]: https://github.com/moby/vpnkit/pull/213

