# Weekly VPNKit dev report for 2017-05-08 to 2017-05-14 (week 19)

This report covers weekly developments in the [moby/vpnkit], [mirage/ocaml-dns], [mirage/ocaml-hvsock], [djs55/ocaml-osx-dnssd], [mirage/mirage-tcpip] and [djs55/ocaml-dns-forward] repositories. These form the basis of the VPNKit toolkit used to translate container network traffic into native platform socket calls on Windows and OSX.

This week primarily saw fixes in the MirageOS TCP/IP stack relating to MTU handling.  There were a couple of library releases with relevant fixes: [tcpip-3.1.1](https://github.com/mirage/mirage-tcpip/releases/tag/v3.1.1) fixed parsing issues, and [tcpip-3.1.2](https://github.com/mirage/mirage-tcpip/releases/tag/v3.1.2) limited the TCP MSS to never exceed the local MTU, which was a problem on virtio-based backends.

VPNKit also got a new feature to add builtin DNS names, which make it easier to map hostnames into virtual IP addresses being managed by VPNKit. This patch added a command-line argument `--host-names` that accepts a comma-separated list of DNS names which will be mapped to the current host virtual IP ([moby/vpnkit#220] [@djs55]).  The default name is `vpnkit.host` but this can be overriden or extended.

## PRs merged

- Compatibility with lwt >= 2.7.0 ([mirage/mirage-tcpip#308] [@djs55])
- Stop sending overly large packets greater than the MTU ([mirage/mirage-tcpip#309] [@djs55] [@avsm] [@hannesm])
- Prepare to release v3.1.1 [mirage/mirage-tcpip#311] [@yomimono] [@djs55]
- Prepare to release v3.1.2 [mirage/mirage-tcpip#312] [@hannesm] [@djs55]

Other reports in this series can be browsed directly in the repository at [moby/vpnkit:/reports](https://github.com/moby/vpnkit/tree/master/reports/).

[@avsm]: https://github.com/avsm
[@djs55]: https://github.com/djs55
[@hannesm]: https://github.com/hannesm
[@yomimono]: https://github.com/yomimono
[djs55/ocaml-dns-forward]: https://github.com/djs55/ocaml-dns-forward
[djs55/ocaml-osx-dnssd]: https://github.com/djs55/ocaml-osx-dnssd
[mirage/mirage-tcpip]: https://github.com/mirage/mirage-tcpip
[mirage/mirage-tcpip#308]: https://github.com/mirage/mirage-tcpip/pull/308
[mirage/mirage-tcpip#309]: https://github.com/mirage/mirage-tcpip/pull/309
[mirage/mirage-tcpip#311]: https://github.com/mirage/mirage-tcpip/pull/311
[mirage/mirage-tcpip#312]: https://github.com/mirage/mirage-tcpip/pull/312
[mirage/ocaml-dns]: https://github.com/mirage/ocaml-dns
[mirage/ocaml-hvsock]: https://github.com/mirage/ocaml-hvsock
[moby/vpnkit]: https://github.com/moby/vpnkit
[moby/vpnkit#220]: https://github.com/moby/vpnkit/pull/220
[moby/vpnkit#221]: https://github.com/moby/vpnkit/issues/221


